/*
 *      SandstoneAPI - Minecraft Server Modding API
 *
 *         The MIT License (MIT)
 *
 *      Copyright (c) Sandstone <https://github.com/ProjectSandstone/>
 *      Copyright (c) contributors
 *
 *
 *      Permission is hereby granted, free of charge, to any person obtaining a copy
 *      of this software and associated documentation files (the "Software"), to deal
 *      in the Software without restriction, including without limitation the rights
 *      to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *      copies of the Software, and to permit persons to whom the Software is
 *      furnished to do so, subject to the following conditions:
 *
 *      The above copyright notice and this permission notice shall be included in
 *      all copies or substantial portions of the Software.
 *
 *      THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *      IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *      FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *      AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *      LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *      OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 *      THE SOFTWARE.
 */
package com.github.projectsandstone.api

import com.github.jonathanxd.iutils.text.localizer.TextLocalizer
import com.github.projectsandstone.api.constants.SandstonePlugin
import com.github.projectsandstone.api.event.SandstoneEventFactory
import com.github.projectsandstone.api.event.SandstoneEventFactoryCache
import com.github.projectsandstone.api.logging.LoggerFactory
import com.github.projectsandstone.api.plugin.PluginManager
import com.github.projectsandstone.api.scheduler.Scheduler
import com.github.projectsandstone.api.service.ServiceManager
import com.github.projectsandstone.api.util.version.Version
import com.github.projectsandstone.api.world.World
import com.github.projectsandstone.eventsys.event.EventManager
import org.slf4j.Logger
import java.nio.file.Path
import javax.inject.Inject
import javax.inject.Named

object Sandstone {
    /**
     * Game instance
     */
    @Inject
    lateinit var game: Game
        private set
        @JvmStatic get

    /**
     * Logger
     */
    @Inject
    lateinit var logger: Logger
        private set
        @JvmStatic get

    /**
     * Logger factory
     */
    @Inject
    lateinit var loggerFactory: LoggerFactory
        private set
        @JvmStatic get

    /**
     * Sandstone path
     */
    @Inject
    @field:Named("sandstonePath")
    lateinit var sandstonePath: Path
        private set
        @JvmStatic get

    /**
     * Sandstone plugin version. Generally the API version, for platform version uses: [Platform.platformVersion],
     * and for implementation version uses: [Implementation.version].
     */
    @JvmStatic
    val apiVersion: Version
        get() = SandstonePlugin.version

    /**
     * Sandstone plugin manager.
     */
    @JvmStatic
    val pluginManager: PluginManager
        get() = this.game.pluginManager

    /**
     * Sandstone scheduler.
     */
    @JvmStatic
    val scheduler: Scheduler
        get() = this.game.scheduler

    /**
     * Sandstone running platform.
     */
    @JvmStatic
    val platform: Platform
        get() = this.game.platform

    /**
     * Sandstone API Implementation.
     */
    @Inject
    lateinit var implementation: Implementation
        private set
        @JvmStatic get

    /**
     * Sandstone event manager.
     */
    @JvmStatic
    val eventManager: EventManager
        get() = this.game.eventManager

    /**
     * Sandstone event factory (generated by apt).
     */
    @JvmStatic
    val eventFactory: SandstoneEventFactory
        get() = SandstoneEventFactoryCache.getInstance()

    /**
     * Sandstone object factory.
     */
    @JvmStatic
    val objectFactory: SandstoneObjectFactory
        get() = this.game.objectFactory

    /**
     * Sandstone object helper.
     */
    @JvmStatic
    val objectHelper: SandstoneObjectHelper
        get() = this.game.objectHelper

    /**
     * Sandstone service manager.
     */
    @JvmStatic
    val serviceManager: ServiceManager
        get() = this.game.serviceManager

    /**
     * Sandstone server.
     */
    @JvmStatic
    val server: Server
        get() = this.game.server

    /**
     * Sandstone server worlds.
     */
    @JvmStatic
    val worlds: Collection<World>
        get() = this.game.server.worlds

    /**
     * Sandstone text localizer.
     */
    @JvmStatic
    val localizer: TextLocalizer
        get() = this.game.textLocalizer

}